Lua脚本语言学习二(环境)

  ⋅   :492  ⋅   :0  ⋅   Lua

这里我们只讨论lnmp环境下载的lua环境配置。

ngx_lua_module 是一个nginx http模块,它把 lua 解析器内嵌到 nginx,用来解析并执行lua 语言编写的网页后台脚本。

特性:

  • 支持Windows和Linux平台。
  • 支持高并发高性能。
  • HTML网页中内嵌LUA脚本代码,类似于PHP。
  • 支持非阻塞的数据库操作,目前只支持MYSQL。
  • 支持异步的文件IO操作。
  • 支持非阻塞的SOCKET IO操作。

下面简要介绍下 ngx_lua_module 模块的安装。

方式一:使用大牛 ZhangYichun 提供的集成包快速安装。

非常简单,下载 ngx_openresty,该集成包中有:Nginx,Lua或Luajit,ngx_lua,以及一些有用的Nginx第三方模块。

方式二:Ngx_lua可以手动编译进Nginx。

首先,我的 Nginx 安装路径为:/usr/local/nginx。

我将尝试编译的两个模块:echo,lua。

所需要的模块如下:

liujit             http://luajit.org
lua                http://www.lua.org
ngx_devel_kit      https://github.com/simpl/ngx_devel_kit
echo-nginx-module  https://github.com/agentzh/echo-nginx-module
lua-nginx-module   https://github.com/chaoslawful/lua-nginx-module

安装步骤:

1、Luajit2.0(推荐)或者 Lua5.1(Lua5.2暂不支持)

wget http://luajit.org/download/LuaJIT-2.0.0-beta9.tar.gz
tar zxvf LuaJIT-2.0.0-beta9.tar.gz
cd LuaJIT-2.0.0-beta9
make 
make install PREFIX=/usr/local/luajit

Note: to avoid overwriting a previous version,
the beta test releases only install the LuaJIT executable under the versioned name (i.e. luajit-2.0.0-beta10). 
You probably want to create a symlink for convenience, with a command like this:

ln -sf luajit-2.0.0-beta9 /usr/local/bin/luajit (加上这句命令,系统会提示)

下面需要配置一下 luajit 或 lua 的环境变量(Nginx编译时需要):

-- luajit --
# tell nginx's build system where to find LuaJIT:
export LUAJIT_LIB=/path/to/luajit/lib
export LUAJIT_INC=/path/to/luajit/include/luajit-2.0

-- lua --
# or tell where to find Lua if using Lua instead:
export LUA_LIB=/path/to/lua/lib
export LUA_INC=/path/to/lua/include

我的测试环境里,配置如下:

export LUAJIT_LIB=/usr/local/luajit/lib
export LUAJIT_INC=/usr/local/luajit/include/luajit-2.0

2、安装 ngx_devel_kit (NDK) 模块

cd /usr/local
git clone https://github.com/simpl/ngx_devel_kit.git

下载完成后,将在 /usr/local/ 目录下生成子目录 ngx_devel_kit。

3、安装 lua-nginx-module 模块

cd /usr/local
git clone https://github.com/chaoslawful/lua-nginx-module.git

下载完成后,将在 /usr/local/ 目录下生成子目录 lua-nginx-module。

安装 echo-nginx-module模块

cd /usr/local
git clone https://github.com/agentzh/echo-nginx-module.git

4、重新编译Nginx,需要注意编译顺序!

./configure --prefix=/usr/local/nginx 
            --with-ld-opt=-Wl,-rpath,/usr/local/luajit/lib 
            --add-module=/usr/local/ngx_devel_kit 
            --add-module=/usr/local/echo-nginx-module 
            --add-module=/usr/local/lua-nginx-module
make -j2
make install

如果你是用lnmp.org的安装包

你可以打开lnmp1.2-full/include/upgrade_nginx.sh,然后修改Nginx_Modules_Arguments

Nginx_Modules_Arguments="--with-ld-opt=-Wl,-rpath,/usr/local/luajit/lib --add-module=/usr/local/ngx_devel_kit --add-module=/usr/local/echo-nginx-module --add-module=/usr/local/lua-nginx-module"

然后升级一下nginx即可

./upgrade.sh nginx

注释:重新编译 Nginx 二进制,Nginx 需要 quit 再启动。而普通配置更新则 reload 即可:

kill -HUP `cat /usr/local/nginx/logs/nginx.pid`
/usr/local/nginx/sbin/nginx -s reload

模块编译成功!

重启Nginx服务器!
我在编译安装 Nginx 的第三方模块时,碰到一个错误:

/usr/local/nginx/sbin/ngxin -s reload
/usr/local/nginx/sbin/nginx: error while loading shared libraries: libluajit-5.1.so.2: cannot open shared object file: No such file or directory

百事不得其解,后来Google之,发现了解决办法。

在 Nginx 编译时,需要指定 RPATH,加入下面选项即可:

./configure --with-ld-opt="-Wl,-rpath,$LUAJIT_LIB"
或者
export LD_LIBRARY_PATH=/usr/local/lib/:$LD_LIBRARY_PATH

5、测试Lua

在Nginx.conf 配置文件中,加入以下代码:

location /echo {
	default_type 'text/plain';
	echo 'hello echo';
}

location /lua {
	default_type 'text/plain';
    content_by_lua 'ngx.say("hello, lua")';
}
重启Nginx服务器:

使用curl测试:


lua_test.png

本文来源:http://blog.csdn.net/vboy1010/article/details/7868645

ngx_lua模块文档:http://wiki.nginx.org/HttpLuaModule


标签:lua 环境

如需评论,请填写表单。
换一个

记住我的信息